local constructors = {}
_G.register = function(class, constructor)
    constructors[class] = constructor
end

_G.new = function(class)
    if type(class) == "cdata" then -- placement new
        return function(t)
            if type(t) == "table" then
                for k, v in pairs(t) do
                    class[k] = v
                end
            end
            return class
        end
    end
    return constructors[class] or function(args)
        local obj = ffi.cast(class .. "*", malloc(ffi.sizeof(class)))
        if type(args) == "table" then
            for k, v in pairs(args) do
                obj[k] = v
            end
        else
            obj[0] = args
        end
        return obj
    end
end

_G.delete = function(obj)
    free(obj)
end